monads-tf-0.3.0.1: Monad classes, using type families

Copyright | (c) Andy Gill 2001 (c) Oregon Graduate Institute of Science and Technology 2001
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | non-portable (type families)
Safe Haskell | None
Language | GHC2021

Control.Monad.RWS.Strict

Contents

- The RWS monad
- The RWST monad transformer
- Strict Reader-writer-state monads

Description

Strict RWS monad.

Inspired by the paper /Functional Programming with Overloading and Higher-Order Polymorphism/, Mark P Jones (http://web.cecs.pdx.edu/~mpj/) Advanced School of Functional Programming, 1995.

Synopsis

- type RWS r w s = RWST r w s Identity
- runRWS :: RWS r w s a -> r -> s -> (a, s, w)
- evalRWS :: RWS r w s a -> r -> s -> (a, w)
- execRWS :: RWS r w s a -> r -> s -> (s, w)
- mapRWS :: ((a, s, w) -> (b, s, w')) -> RWS r w s a -> RWS r w' s b
- withRWS :: (r' -> s -> (r, s)) -> RWS r w s a -> RWS r' w s a
- newtype RWST r w s (m :: Type -> Type) a = RWST {
  - runRWST :: r -> s -> m (a, s, w)
  }
- evalRWST :: Monad m => RWST r w s m a -> r -> s -> m (a, w)
- execRWST :: Monad m => RWST r w s m a -> r -> s -> m (s, w)
- mapRWST :: (m (a, s, w) -> n (b, s, w')) -> RWST r w s m a -> RWST r w' s n b
- withRWST :: forall r' s r w (m :: Type -> Type) a. (r' -> s -> (r, s)) -> RWST r w s m a -> RWST r' w s m a
- module Control.Monad.RWS.Class
- module Control.Monad
- module Control.Monad.Fix
- module Control.Monad.Trans
- module Data.Monoid

# The RWS monad

type RWS r w s = RWST r w s Identity Source #

A monad containing an environment of type `r`, output of type `w` and an updatable state of type `s`.

runRWS :: RWS r w s a -> r -> s -> (a, s, w) Source #

Unwrap an RWS computation as a function. (The inverse of `rws`.)

evalRWS Source #

Arguments

:: RWS r w s a | RWS computation to execute
-> r | initial environment
-> s | initial value
-> (a, w) | final value and output

Evaluate a computation with the given initial state and environment, returning the final value and output, discarding the final state.

execRWS Source #

Arguments

:: RWS r w s a | RWS computation to execute
-> r | initial environment
-> s | initial value
-> (s, w) | final state and output

Evaluate a computation with the given initial state and environment, returning the final state and output, discarding the final value.

mapRWS :: ((a, s, w) -> (b, s, w')) -> RWS r w s a -> RWS r w' s b Source #

Map the return value, final state and output of a computation using the given function.

-     runRWS (mapRWS f m) r s = f (runRWS m r s)

withRWS :: (r' -> s -> (r, s)) -> RWS r w s a -> RWS r' w s a Source #

``withRWS` f m` executes action `m` with an initial environment and state modified by applying `f`.

-     runRWS (withRWS f m) r s = uncurry (runRWS m) (f r s)

# The RWST monad transformer

newtype RWST r w s (m :: Type -> Type) a Source #

A monad transformer adding reading an environment of type `r`, collecting an output of type `w` and updating a state of type `s` to an inner monad `m`.

Constructors

RWST |

Fields

- runRWST :: r -> s -> m (a, s, w)

#### Instances

Instances details

Monoid w => MonadTrans (RWST r w s) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods lift :: Monad m => m a -> RWST r w s m a Source #
(Monoid w, MonadIO m) => MonadIO (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods liftIO :: IO a -> RWST r w s m a Source #
Contravariant m => Contravariant (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods contramap :: (a' -> a) -> RWST r w s m a -> RWST r w s m a' Source # (>$) :: b -> RWST r w s m b -> RWST r w s m a Source #
(Monoid w, Functor m, MonadPlus m) => Alternative (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods empty :: RWST r w s m a Source # (<|>) :: RWST r w s m a -> RWST r w s m a -> RWST r w s m a Source # some :: RWST r w s m a -> RWST r w s m [a] Source # many :: RWST r w s m a -> RWST r w s m [a] Source #
(Monoid w, Functor m, Monad m) => Applicative (RWST r w s m) |

Instance details

Defined in Control.Monad.Trans.RWS.Strict

Methods

pure :: a -> RWST r w s m a Source #

(<*>) :: RWST r w s m (a -> b) -> RWST r w s m a -> RWST r w s m b Source #

liftA2 :: (a -> b -> c) -> RWST r w s m a -> RWST r w s m b -> RWST r w s m c Source #

(*>) :: RWST r w s m a -> RWST r w s m b -> RWST r w s m b Source #

(<*) :: RWST r w s m a -> RWST r w s m b -> RWST r w s m a Source #

Functor m => Functor (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods fmap :: (a -> b) -> RWST r w s m a -> RWST r w s m b Source # (<$) :: a -> RWST r w s m b -> RWST r w s m a Source #
(Monoid w, Monad m) => Monad (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods (>>=) :: RWST r w s m a -> (a -> RWST r w s m b) -> RWST r w s m b Source # (>>) :: RWST r w s m a -> RWST r w s m b -> RWST r w s m b Source # return :: a -> RWST r w s m a Source #
(Monoid w, MonadPlus m) => MonadPlus (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods mzero :: RWST r w s m a Source # mplus :: RWST r w s m a -> RWST r w s m a -> RWST r w s m a Source #
(Monoid w, MonadFail m) => MonadFail (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods fail :: String -> RWST r w s m a Source #
(Monoid w, MonadFix m) => MonadFix (RWST r w s m) |
Instance details Defined in Control.Monad.Trans.RWS.Strict Methods mfix :: (a -> RWST r w s m a) -> RWST r w s m a Source #
(Monoid w, MonadCont m) => MonadCont (RWST r w s m) Source # |
Instance details Defined in Control.Monad.Cont.Class Methods callCC :: ((a -> RWST r w s m b) -> RWST r w s m a) -> RWST r w s m a Source #
(Monoid w, MonadError m) => MonadError (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Except.Class

Associated Types

type ErrorType (RWST r w s m) |
Instance details Defined in Control.Monad.Except.Class type ErrorType (RWST r w s m) = ErrorType m

Methods

throwError :: ErrorType (RWST r w s m) -> RWST r w s m a Source #

catchError :: RWST r w s m a -> (ErrorType (RWST r w s m) -> RWST r w s m a) -> RWST r w s m a Source #

(Monoid w, Monad m) => MonadRWS (RWST r w s m) Source # |
Instance details Defined in Control.Monad.RWS.Class
(Monoid w, Monad m) => MonadReader (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Reader.Class

Associated Types

type EnvType (RWST r w s m) |
Instance details Defined in Control.Monad.Reader.Class type EnvType (RWST r w s m) = r

Methods

ask :: RWST r w s m (EnvType (RWST r w s m)) Source #

local :: (EnvType (RWST r w s m) -> EnvType (RWST r w s m)) -> RWST r w s m a -> RWST r w s m a Source #

(Monad m, Monoid w) => MonadState (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.State.Class

Associated Types

type StateType (RWST r w s m) |
Instance details Defined in Control.Monad.State.Class type StateType (RWST r w s m) = s

Methods

get :: RWST r w s m (StateType (RWST r w s m)) Source #

put :: StateType (RWST r w s m) -> RWST r w s m () Source #

(Monoid w, Monad m) => MonadWriter (RWST r w s m) Source # |

Instance details

Defined in Control.Monad.Writer.Class

Associated Types

type WriterType (RWST r w s m) |
Instance details Defined in Control.Monad.Writer.Class type WriterType (RWST r w s m) = w

Methods

tell :: WriterType (RWST r w s m) -> RWST r w s m () Source #

listen :: RWST r w s m a -> RWST r w s m (a, WriterType (RWST r w s m)) Source #

pass :: RWST r w s m (a, WriterType (RWST r w s m) -> WriterType (RWST r w s m)) -> RWST r w s m a Source #

Generic (RWST r w s m a) |

Instance details

Defined in Control.Monad.Trans.RWS.Strict

Associated Types

type Rep (RWST r w s m a) |
Instance details Defined in Control.Monad.Trans.RWS.Strict type Rep (RWST r w s m a) = D1 ('MetaData "RWST" "Control.Monad.Trans.RWS.Strict" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "RWST" 'PrefixI 'True) (S1 ('MetaSel ('Just "runRWST") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (r -> s -> m (a, s, w)))))

Methods

from :: RWST r w s m a -> Rep (RWST r w s m a) x Source #

to :: Rep (RWST r w s m a) x -> RWST r w s m a Source #

type ErrorType (RWST r w s m) Source # |
Instance details Defined in Control.Monad.Except.Class type ErrorType (RWST r w s m) = ErrorType m
type EnvType (RWST r w s m) Source # |
Instance details Defined in Control.Monad.Reader.Class type EnvType (RWST r w s m) = r
type StateType (RWST r w s m) Source # |
Instance details Defined in Control.Monad.State.Class type StateType (RWST r w s m) = s
type WriterType (RWST r w s m) Source # |
Instance details Defined in Control.Monad.Writer.Class type WriterType (RWST r w s m) = w
type Rep (RWST r w s m a) |
Instance details Defined in Control.Monad.Trans.RWS.Strict type Rep (RWST r w s m a) = D1 ('MetaData "RWST" "Control.Monad.Trans.RWS.Strict" "transformers-0.6.1.1-inplace" 'True) (C1 ('MetaCons "RWST" 'PrefixI 'True) (S1 ('MetaSel ('Just "runRWST") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 (r -> s -> m (a, s, w)))))

evalRWST Source #

Arguments

:: Monad m |
=> RWST r w s m a | computation to execute
-> r | initial environment
-> s | initial value
-> m (a, w) | computation yielding final value and output

Evaluate a computation with the given initial state and environment, returning the final value and output, discarding the final state.

execRWST Source #

Arguments

:: Monad m |
=> RWST r w s m a | computation to execute
-> r | initial environment
-> s | initial value
-> m (s, w) | computation yielding final state and output

Evaluate a computation with the given initial state and environment, returning the final state and output, discarding the final value.

mapRWST :: (m (a, s, w) -> n (b, s, w')) -> RWST r w s m a -> RWST r w' s n b Source #

Map the inner computation using the given function.

-     runRWST (mapRWST f m) r s = f (runRWST m r s)

withRWST :: forall r' s r w (m :: Type -> Type) a. (r' -> s -> (r, s)) -> RWST r w s m a -> RWST r' w s m a Source #

``withRWST` f m` executes action `m` with an initial environment and state modified by applying `f`.

-     runRWST (withRWST f m) r s = uncurry (runRWST m) (f r s)

# Strict Reader-writer-state monads

module Control.Monad.RWS.Class

module Control.Monad

module Control.Monad.Fix

module Control.Monad.Trans

module Data.Monoid